#!/usr/bin/perl
use Switch;

$size = 25;
$prefix = "test";
$num_formulas = 1000;
$num_propvars = 5;
$max_index = 100;

for ($i = 0; $i < $num_formulas; $i++) {
  $factfilename = "size" . $size . $prefix . $i . ".fact";
	$willfilename = "size" . $size . $prefix . $i . ".will";
  open FACT, ">", $factfilename;
	# satisfy fact syntax
	  print FACT "(equal_c SAT ";
	open WILL, ">", $willfilename;
	# satisfy will syntax
	  print WILL "Logic: GML\n";
	random_formula($size);
	print FACT ")\n";
	close FACT;
	close WILL;
}

sub random_formula {
  local ($size) = $_[0];

	# terminate on size 1 and return prop variable
	if ($size == 1) {
	  $num = int(rand($num_propvars));
	  print FACT "p" . $num . " ";
	  print WILL "p" . $num . " ";;
	} 
	if ($size == 2) { 
	# guess unary connective
	  $conn = int(rand(2));
		switch ($conn) {
		  case 0 { 
			  print WILL "(~"; 
				print FACT "(not ";
			  random_formula(1);
				print WILL ")";
				print FACT ")"; 
			}
			case 1  {
			  $n = int(rand($max_index));
			  print WILL  "(<" . $n . ">";
				print FACT "(min " . ($n+1) . " r ";
				random_formula(1);
				print WILL ")";
				print FACT ")";
		  }
		}
	} 
	if ($size > 2) {
    # guess a connective
	  $conn = int(rand(4));
	  switch ($conn) {
      case 0 { 
		    $split = 1 + int(rand($size - 2));
				print WILL "(";
				print FACT "(and ";
				random_formula($split);
				print WILL " & ";
				random_formula ($size - $split - 1);
				print WILL ")";
				print FACT ")";
		  }
      case 1 { 
		    $split = 1 + int(rand($size - 2));
				print WILL "(";
				print FACT "(or ";
				random_formula($split);
				print WILL " v ";
				random_formula ($size - $split - 1);
				print WILL ")";
				print FACT ")";
		  }
	  	case 2 { 
			  print WILL "(~";
				print FACT "(not ";
				random_formula ($size -1);
				print WILL ")";
				print FACT ")";
      }
	  	case 3 { 
			  $n = int(rand($max_index));
			  print WILL  "(<" . $n . ">";
				print FACT "(min " . ($n+1) . " r ";
				random_formula($size-1);
				print WILL ")";
				print FACT ")";
      }
	  }
	}
}


