#ifndef NODE_H
#define NODE_H

#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

class Node {
	friend ostream& operator<<(ostream& out, const Node& n);
	private:
		//size comes from the premise. Premise with n literals gives 2^n size.
		int size;

		// bit vector: 0 = valuation not admitted, 1 = valuation is.
		vector<bool> valuations;

	public:
		Node(){size = 0;};
		Node(int no_of_atoms);

		void allow(int a);
		void disallow(int d);
	
		//Copyable, assignable and comparable for use in STL
		bool operator==(const Node& other) const;		
			
		// For checking supersets.
		bool operator<(const Node& other) const;

};

#endif
