#include "setofconclusions.h"

SetOfConclusions::SetOfConclusions(int n, const vector<vector<bool> >& set){
	no_of_literals=n;
	
	/* To limitate code change the new type given in (vector<unsigned int>) is converted to the old type vector<vector<TruthAssignment>>
		 Each unsigned int corresponds to a rule instance (a node of the tree). Each node is a set of truth assignments. */
	int limit = 1 << n;
	for(unsigned int i=0; i <	set.size(); i++){
                vector<bool> node = set[i];
		vector<TruthAssignment> rule;
		for(int j=0; j < limit; j++){
			if(node[j])
				rule.push_back(TruthAssignment(j,n));
		}		
		rules.push_back(rule);
	}
}

bdd SetOfConclusions::get_jth_conclusion(bdd** underlying, int j){
	bdd b = bdd_false();
	for(unsigned int i=0; i < rules[j].size(); i++){
		bdd clause = bdd_true();
		for(int k=0; k < no_of_literals; k++){
			if(rules[j][i].get_p_i(k)==1)
				clause = bdd_and(clause, *(underlying[k]));
			if(rules[j][i].get_p_i(k)==0)
				clause = bdd_and(clause, bdd_not(*(underlying[k])));
		}
		b = bdd_or(clause, b);
   		
	}
	return b;
}
	
