#include "sizefunctions.h"

/* Functions for calculating size of a linear program */
int sizeofcoef(int a){
	int result = 1;
	while (a >>= 1) 
		++result;
	return result;
}

int sizeofcoef(Rational a){
	return 1 + sizeofcoef(a.get_top()) + sizeofcoef(a.get_bot());
}

template <class T>
int sizeoflp(const int n, const int m, T* a, T* b){
	int sum = 1 + n + m;
	for(int i=0; i < n; i++)
		sum+=sizeofcoef(a[i]);
	for(int j=0; j < m; j++)
		sum+=sizeofcoef(b[j]);
	return sum;
}

template int sizeoflp<int>(const int, const int, int*, int*);
template int sizeoflp<Rational>(const int, const int, Rational*, Rational*);
